VERSION 5.00
Begin VB.Form frmTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Mouse and KeyBoard Hook Test"
   ClientHeight    =   3690
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4740
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3690
   ScaleWidth      =   4740
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text2 
      Height          =   1455
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   2040
      Width           =   2655
   End
   Begin VB.TextBox Text1 
      Height          =   1695
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   4215
   End
   Begin VB.Label Label1 
      Height          =   1455
      Left            =   3120
      TabIndex        =   2
      Top             =   2040
      Width           =   1455
   End
End
Attribute VB_Name = "frmTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim WithEvents sh As cSystemHook
Attribute sh.VB_VarHelpID = -1

Private Declare Function GetForegroundWindow& Lib "user32" ()
Private Declare Function GetWindowThreadProcessId& Lib "user32" (ByVal hwnd As Long, lpdwProcessId As Long)
Private Declare Function GetKeyboardLayout& Lib "user32" (ByVal dwLayout As Long)
Private Declare Function MapVirtualKeyEx Lib "user32" Alias "MapVirtualKeyExA" (ByVal uCode As Long, ByVal uMapType As Long, ByVal dwhkl As Long) As Long

Private Sub Form_Load()
   Text1 = "Mouse activity log:"
   Text2 = "Keyboard activity log:"
   Set sh = New cSystemHook
   sh.SetHook
End Sub

Private Sub sh_KeyDown(KeyCode As Integer, Shift As Integer)
   Dim s As String
   s = "KeyCode " & KeyCode
   s = s + CharFromKeyCode(KeyCode)
   If Shift = vbShiftMask Then s = s & " + Shift "
   If Shift = vbCtrlMask Then s = s & " + Ctrl "
   If Shift = vbAltMask Then s = s & " + Alt "
   Text2 = Text2 & vbCrLf & s & " down"
' Uncomment following string and all your input will be replaced with "a"
'   KeyCode = vbKeyA
End Sub

Private Sub sh_KeyUp(KeyCode As Integer, Shift As Integer)
   Dim s As String
   s = "KeyCode " & KeyCode
   s = s + CharFromKeyCode(KeyCode)
   If Shift = vbShiftMask Then s = s & " + Shift "
   If Shift = vbCtrlMask Then s = s & " + Ctrl "
   If Shift = vbAltMask Then s = s & " + Alt "
   Text2 = Text2 & vbCrLf & s & " up"
End Sub

Private Sub sh_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  Dim s As String
  If Button = vbLeftButton Then s = "Left Button "
  If Button = vbRightButton Then s = "Right Button "
  If Button = vbMiddleButton Then s = "Middle Button "
  If Shift = vbShiftMask Then s = s & "+ Shift "
  If Shift = vbCtrlMask Then s = s & "+ Ctrl "
  If Shift = vbAltMask Then s = s & "+ Alt "
  Text1 = Text1 & vbCrLf & s & "Down at pos (pixels): " & CStr(x) & " , " & CStr(y)
End Sub

Private Sub sh_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  Dim s As String
  If Button = vbLeftButton Then s = "Left Button "
  If Button = vbRightButton Then s = "Right Button "
  If Button = vbMiddleButton Then s = "Middle Button "
  If Shift = vbShiftMask Then s = s & "+ Shift "
  If Shift = vbCtrlMask Then s = s & "+ Ctrl "
  If Shift = vbAltMask Then s = s & "+ Alt "
  Text1 = Text1 & vbCrLf & s & "Up at pos (pixels): " & CStr(x) & " , " & CStr(y)
End Sub

Private Sub sh_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  Dim s As String
  If Button = vbLeftButton Then s = "Left Button "
  If Button = vbRightButton Then s = "Right Button "
  If Button = vbMiddleButton Then s = "Middle Button "
  If Shift = vbShiftMask Then s = s & "+ Shift "
  If Shift = vbCtrlMask Then s = s & "+ Ctrl "
  If Shift = vbAltMask Then s = s & "+ Alt "
  Label1 = "Mouse info" & vbCrLf & "X = " & x & "  Y= " & y & vbCrLf
  If s <> "" Then Label1 = Label1 & "Extra Info: " & vbCrLf & s & "pressed"
End Sub

Private Sub Form_Unload(Cancel As Integer)
  sh.RemoveHook
  Set sh = Nothing
End Sub

Private Function CharFromKeyCode(k As Integer) As String
   Dim s As String
   Select Case k
          Case vbKeyBack:     s = "BackSpace"
          Case vbKeyTab:      s = "Tab"
          Case vbKeyClear:    s = "Clear"
          Case vbKeyReturn:   s = "Enter"
          Case vbKeyShift:    s = "Shift"
          Case vbKeyControl:  s = "Ctrl"
          Case vbKeyMenu:     s = "Alt"
          Case vbKeyPause:    s = "Pause"
          Case vbKeyCapital:  s = "CapsLock"
          Case vbKeyEscape:   s = "ESC"
          Case vbKeySpace:    s = "SPACEBAR"
          Case vbKeyPageUp:   s = "PAGE UP"
          Case vbKeyPageDown: s = "PAGE DOWN"
          Case vbKeyEnd:      s = "END"
          Case vbKeyHome:     s = "HOME"
          Case vbKeyLeft:     s = "LEFT ARROW"
          Case vbKeyUp:       s = "UP ARROW"
          Case vbKeyRight:    s = "RIGHT ARROW"
          Case vbKeyDown:     s = "DOWN ARROW"
          Case vbKeySelect:   s = "SELECT"
          Case vbKeyPrint:    s = "PRINT SCREEN"
          Case vbKeyExecute:  s = "EXECUTE"
          Case vbKeySnapshot: s = "SNAPSHOT"
          Case vbKeyInsert:   s = "INS"
          Case vbKeyDelete:   s = "DEL"
          Case vbKeyHelp:     s = "HELP"
          Case vbKeyNumlock:  s = "NUM LOCK"
          Case vbKey0 To vbKey9: s = Chr$(k)
          Case vbKeyA To vbKeyZ: s = Chr$(MapVirtualKeyEx(k, 2, GetKeyboardLayout(GetWindowThreadProcessId(GetForegroundWindow, 0))))
          Case vbKeyF1 To vbKeyF16: s = "F" & CStr(k - 111)
          Case vbKeyNumpad0 To vbKeyNumpad9: s = "Numpad " & CStr(k - 95)
          Case vbKeyMultiply: s = "Numpad {*}"
          Case vbKeyAdd: s = "Numpad {+}"
          Case vbKeySeparator: s = "Numpad {ENTER}"
          Case vbKeySubtract: s = "Numpad {-}"
          Case vbKeyDecimal: s = "Numpad {.}"
          Case vbKeyDivide: s = "Numpad {/}"
          Case Else
               s = Chr$(MapVirtualKeyEx(k, 2, GetKeyboardLayout(GetWindowThreadProcessId(GetForegroundWindow, 0))))
   End Select
   CharFromKeyCode = "[" & s & " key]"
End Function

Private Sub sh_SystemKeyDown(KeyCode As Integer)
   Dim s As String
   s = "SystemKey " & KeyCode
   s = s + CharFromKeyCode(KeyCode)
   Text2 = Text2 & vbCrLf & s & " down"
   If KeyCode = vbKeyF4 Then KeyCode = 0
End Sub
